package eu.univento.core.commands;

import java.util.List;

import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import eu.univento.core.Core;
import eu.univento.core.api.AutoCommand;
import eu.univento.core.api.Messages;
import eu.univento.core.api.Settings;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.core.api.player.Perms.Ranks;

/**
 * mutes the whole server
 * @author joethei
 * @version 1.0
 */
public class GlobalMute extends AutoCommand<Core>{

	/**
	 * @param plugin main class
	 * @param command command to execute
	 * @param description describes the command
	 * @param aliases aliases of command
	 */
	public GlobalMute(Core plugin, String command, String description, String[] aliases) {
		super(plugin, command, description, aliases);
	}

	@Override
	public boolean execute(CommandSender sender, String label, String[] args) {
		if(sender instanceof Player) {
			CustomPlayer p = CustomPlayer.getPlayer(sender.getName());
			if(p.isAllowed(Ranks.Moderator)) {
				if(Settings.isMute()) {
					Settings.setMute(false);
					p.sendMessage("cGlobal Mute deaktiviert");
				}else {
					Settings.setMute(true);
					p.sendMessage("aGlobal Mute aktiviert");
				}
			}else {
				p.sendMessage(Messages.NO_PERMS);
			}
		}else {
			sender.sendMessage(Messages.NOT_A_PLAYER);
		}
		return false;
	}

	@Override
	public List<String> tabComplete(CommandSender sender, String label, String[] args) {
		return null;
	}

}