package eu.univento.core.commands;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import eu.univento.core.Core;
import eu.univento.core.api.AutoCommand;
import eu.univento.core.api.Messages;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.core.api.player.Perms;
import eu.univento.core.api.player.Perms.Ranks;

/**
 * sets ranks for players
 * @author joethei
 * @version 1.0
 */
public class SetRank extends AutoCommand<Core>{

	/**
	 * @param plugin main class
	 * @param command command to execute
	 * @param description describes the command
	 * @param aliases aliases of command
	 */
	public SetRank(Core plugin, String command, String description, String[] aliases) {
		super(plugin, command, description, aliases);
	}

	@Override
	public boolean execute(CommandSender sender, String label, String[] args) {
		if(sender instanceof Player) {
			CustomPlayer p = CustomPlayer.getPlayer(sender.getName());
			if(p.isAllowed(Ranks.Admin)) {
				if(args.length == 2) {
					Ranks rank = Ranks.valueOf(args[1]);
					if(rank != null) {
						if(Bukkit.getPlayer(args[0]) != null) {
							CustomPlayer player = CustomPlayer.getPlayer(Bukkit.getPlayer(args[0]).getName());
								try {
									Perms.setRank(player, rank);
									p.sendMessage("aDer Rang wurde erfolgreich gesetzt");
								} catch (ClassNotFoundException | SQLException e) {
									e.printStackTrace();
									p.sendMessage(Messages.readString("Messages.UnknownError"));
								}
						}else {
							p.sendMessage(Messages.NOT_ONLINE);
						}	
					}else {
						p.sendMessage("cDen Rang gibt es nicht");
					}
				}else {
					p.sendMessage("cNutze 6/setRank <Spieler> <Rang>");
				}
			}else {
				p.sendMessage(Messages.NO_PERMS);
			}
		}else {
			sender.sendMessage(Messages.NOT_A_PLAYER);
		}
		return true;
	}

	@Override
	public List<String> tabComplete(CommandSender sender, String label, String[] args) {
		List<String> list = new ArrayList<String>();
		
		for(Player players : Bukkit.getOnlinePlayers()) {
			list.add(players.getDisplayName());
		}

		list.add("Admin");
		list.add("Developer");
		list.add("HeadBuilder");
		list.add("Builder");
		list.add("Moderator");
		list.add("Supporter");
		list.add("Youtuber");
		list.add("Premium");
		list.add("Spieler");
		
		return list;
	}
	
	

}